declare Solve SolveStep SolveLoop SolveAll Choose RelationClass
fun {Solve Script}
   {SolveStep {Space.new Script} nil}
end

fun {SolveStep S SolTail}
   case {Space.ask S}
   of failed then SolTail
   [] succeeded then {Space.merge S}|SolTail
   [] alternatives(N) then {SolveLoop S 1 N SolTail}
   end
end

fun lazy {SolveLoop S I N SolTail}
   if I > N then
      SolTail
   elseif I == N then
      {Space.commit S I}
      {SolveStep S SolTail}
   else
      C = {Space.clone S}
      NewTail = {SolveLoop S I+1 N SolTail}
   in
      {Space.commit C I}
      {SolveStep C NewTail}
   end
end

fun {SolveAll F}
   L = {Solve F}
   proc {TouchAll L}
      if L == nil then skip else {TouchAll L.2} end
   end
in
   {TouchAll L}
   L
end

proc {Choose ?X Ys}
   choice Ys=X|_
   [] Yr in Ys=_|Yr {Choose X Yr} end
end

class RelationClass
   attr d
   meth init
      d:={NewDictionary}
   end
   meth assertall(Is)
      for I in Is do {self assert(I)} end
   end
   meth assert(I)
      if {IsDet I.1} then
	 Is={Dictionary.condGet @d I.1 nil} in
	 {Dictionary.put @d I.1 {Append Is [I]}}
      else
	 raise databaseError(nonground(I)) end
      end
   end
   meth query(I)
      if {IsDet I} andthen {IsDet I.1} then
	 {Choose I {Dictionary.condGet @d I.1 nil}}
      else
	 {Choose I {Flatten {Dictionary.items @d}}}
      end
   end
end

declare
GraphRel = {New RelationClass init}
{GraphRel assertall([edge(a b) edge(b c) edge(c d)
		     edge(d e) edge(b e) edge(d f)])}
proc {EdgeP A B} {GraphRel query(edge(A B))} end

{Browse {Search.base.all proc {$ X} {EdgeP b X} end}}

{Browse {Search.base.all proc {$ Sol} A#B = Sol in {EdgeP A B} end}}

{Browse {Search.base.all proc {$ Sol} sol(A B) = Sol in {EdgeP A B} end}}

{Browse {Search.base.all proc {$ Sol} [A B] = Sol in {EdgeP A B} end}}

declare
proc {EdgeP2 X} {GraphRel query(X)} end
{Browse {Search.base.all EdgeP2}}


declare
proc {Path X Y}
   choice
      X = Y
   [] Z in
      {EdgeP Z Y}
      {Path X Z}
   end
end
{Browse {Search.base.all proc {$ X} {Path b X} end}}